Ogre::GLSLESProgramManagerCommon Class Reference

Ogre assumes that there are separate vertex and fragment programs to deal with but GLSL ES has one program object that represents the active vertex and fragment shader objects during a rendering state. More...

`#include <OgreGLSLESProgramManagerCommon.h>`

Inheritance diagram for Ogre::GLSLESProgramManagerCommon:
[legend]

List of all members.

## Public Member Functions

| GLSLESProgramManagerCommon (void)
| ~GLSLESProgramManagerCommon (void)
void | optimiseShaderSource (GLSLESGpuProgram *gpuProgram)
void | extractUniforms (GLuint programObject, const GpuConstantDefinitionMap *vertexConstantDefs, const GpuConstantDefinitionMap *fragmentConstantDefs, GLUniformReferenceList &list)
| Populate a list of uniforms based on a program object.
void | extractConstantDefs (const String &src, GpuNamedConstants &constantDefs, const String &filename)
| Populate a list of uniforms based on GLSL ES source.

## Protected Types

typedef map< String, GLenum >::type | StringToEnumMap

## Protected Member Functions

void | completeDefInfo (GLenum gltype, GpuConstantDefinition &defToUpdate)
| Use type to complete other information.
bool | completeParamSource (const String &paramName, const GpuConstantDefinitionMap *vertexConstantDefs, const GpuConstantDefinitionMap *fragmentConstantDefs, GLUniformReference &refToUpdate)
| Find where the data for a specific uniform should come from, populate.

## Protected Attributes

GLSLESGpuProgram * | mActiveVertexGpuProgram
| Active objects defining the active rendering gpu state.
GLSLESGpuProgram * | mActiveFragmentGpuProgram
StringToEnumMap | mTypeEnumMap
struct glslopt_ctx * | mGLSLOptimiserContext

## Detailed Description

Ogre assumes that there are separate vertex and fragment programs to deal with but GLSL ES has one program object that represents the active vertex and fragment shader objects during a rendering state.

GLSL Vertex and fragment shader objects are compiled separately and then attached to a program object and then the program object is linked. Since Ogre can only handle one vertex program and one fragment program being active in a pass, the GLSL ES Link Program Manager does the same. The GLSL ES Link program manager acts as a state machine and activates a program object based on the active vertex and fragment program. Previously created program objects are stored along with a unique key in a hash_map for quick retrieval the next time the program object is required.

Definition at line 54 of file OgreGLSLESProgramManagerCommon.h.

## Member Typedef Documentation

typedef map<String, GLenum>::type Ogre::GLSLESProgramManagerCommon::StringToEnumMap`[protected]`

Reimplemented in Ogre::GLSLESLinkProgramManager.

Definition at line 61 of file OgreGLSLESProgramManagerCommon.h.

## Constructor & Destructor Documentation

Ogre::GLSLESProgramManagerCommon::GLSLESProgramManagerCommon | ( | void |  | ) |

Ogre::GLSLESProgramManagerCommon::~GLSLESProgramManagerCommon | ( | void |  | ) |

## Member Function Documentation

void Ogre::GLSLESProgramManagerCommon::completeDefInfo | ( | GLenum | gltype,
|  | GpuConstantDefinition & | defToUpdate
| ) |  | `[protected]`

Use type to complete other information.

bool Ogre::GLSLESProgramManagerCommon::completeParamSource | ( | const String & | paramName,
|  | const GpuConstantDefinitionMap * | vertexConstantDefs,
|  | const GpuConstantDefinitionMap * | fragmentConstantDefs,
|  | GLUniformReference & | refToUpdate
| ) |  | `[protected]`

Find where the data for a specific uniform should come from, populate.

void Ogre::GLSLESProgramManagerCommon::extractConstantDefs | ( | const String & | src,
|  | GpuNamedConstants & | constantDefs,
|  | const String & | filename
| ) |  |

Populate a list of uniforms based on GLSL ES source.

Parameters:

  src | Reference to the source code
  list | The defs to populate (will not be cleared before adding, clear it yourself before calling this if that's what you want).
  filename | The file name this came from, for logging errors.

void Ogre::GLSLESProgramManagerCommon::extractUniforms | ( | GLuint | programObject,
|  | const GpuConstantDefinitionMap * | vertexConstantDefs,
|  | const GpuConstantDefinitionMap * | fragmentConstantDefs,
|  | GLUniformReferenceList & | list
| ) |  |

Populate a list of uniforms based on a program object.

Parameters:

  programObject | Handle to the program object to query
  vertexConstantDefs | Definition of the constants extracted from the vertex program, used to match up physical buffer indexes with program uniforms. May be null if there is no vertex program.
  fragmentConstantDefs | Definition of the constants extracted from the fragment program, used to match up physical buffer indexes with program uniforms. May be null if there is no fragment program.
  list | The list to populate (will not be cleared before adding, clear it yourself before calling this if that's what you want).

void Ogre::GLSLESProgramManagerCommon::optimiseShaderSource | ( | GLSLESGpuProgram * | gpuProgram | ) |

## Member Data Documentation

GLSLESGpuProgram* Ogre::GLSLESProgramManagerCommon::mActiveFragmentGpuProgram`[protected]`

Definition at line 59 of file OgreGLSLESProgramManagerCommon.h.

GLSLESGpuProgram* Ogre::GLSLESProgramManagerCommon::mActiveVertexGpuProgram`[protected]`

Active objects defining the active rendering gpu state.

Definition at line 58 of file OgreGLSLESProgramManagerCommon.h.

struct glslopt_ctx* Ogre::GLSLESProgramManagerCommon::mGLSLOptimiserContext`[protected]`

Definition at line 64 of file OgreGLSLESProgramManagerCommon.h.

StringToEnumMap Ogre::GLSLESProgramManagerCommon::mTypeEnumMap`[protected]`

Reimplemented in Ogre::GLSLESLinkProgramManager.

Definition at line 62 of file OgreGLSLESProgramManagerCommon.h.

The documentation for this class was generated from the following file:

- OgreGLSLESProgramManagerCommon.h

Copyright © 2012 Torus Knot Software Ltd
This work is licensed under a Creative Commons Attribution-ShareAlike 3.0 Unported License.
Last modified Sun Sep 2 2012 07:28:04